Bug 785312 - Review Request: e3 - Text editor with key bindings similar to WordStar, Emacs, pico, nedit, or vi
Summary: Review Request: e3 - Text editor with key bindings similar to WordStar, Emacs...
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Jos de Kloe
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2012-01-27 22:56 UTC by Mark McKinstry
Modified: 2014-11-14 20:28 UTC (History)
3 users (show)

Fixed In Version: e3-2.8-6.el7
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2013-05-29 03:05:15 UTC
josdekloe: fedora-review+
gwync: fedora-cvs+


Attachments (Terms of Use)

Description Mark McKinstry 2012-01-27 22:56:00 UTC
spec: http://mmckinst.fedorapeople.org/packages/e3/e3.spec
srpm: http://mmckinst.fedorapeople.org/packages/e3/e3-2.8-1.fc16.src.rpm
scratch: http://koji.fedoraproject.org/koji/taskinfo?taskID=3740531
desc:
e3 is a full-screen, user-friendly text editor with an key bindings similar to
that of either WordStar, Emacs, pico, nedit, or vi.




Regarding the rpmlint output:

> e3.i686: E: statically-linked-binary /usr/bin/e3

This is normal, it is the same way with Debian. http://lintian.debian.org/tags/statically-linked-binary.html

> e3.i686: E: missing-PT_GNU_STACK-section /usr/bin/e3

I've tried various ways to fix this but nothing works. Debian and Ubuntu are the same way so this might be normal.

Comment 1 Jos de Kloe 2012-10-17 20:57:15 UTC
Note for other reviewers: e3 is build from assembly code, there is no c-code in this project. I did not find a specific section in the Fedora Packaging guidelines on how to handle this type of situation. Mark, if you know more examples that have been accepted into Fedora, some pointers might be helpfull in the review process.

The package builds 3 rpms on my Fedora17 x86_64 system.
rpmlint gives these results:

rpmlint e3-2.8-1.fc17.src.rpm
e3.src: W: spelling-error Summary(en_US) pico -> pic, picot, pics
e3.src: W: spelling-error Summary(en_US) nedit -> edit, n edit
e3.src: W: spelling-error %description -l en_US pico -> pic, picot, pics
e3.src: W: spelling-error %description -l en_US nedit -> edit, n edit
1 packages and 0 specfiles checked; 0 errors, 4 warnings.

rpmlint x86_64/e3-2.8-1.fc17.x86_64.rpm
e3.x86_64: W: spelling-error Summary(en_US) pico -> pic, picot, pics
e3.x86_64: W: spelling-error Summary(en_US) nedit -> edit, n edit
e3.x86_64: W: spelling-error %description -l en_US pico -> pic, picot, pics
e3.x86_64: W: spelling-error %description -l en_US nedit -> edit, n edit
e3.x86_64: E: statically-linked-binary /usr/bin/e3
e3.x86_64: E: missing-PT_GNU_STACK-section /usr/bin/e3
e3.x86_64: E: incorrect-fsf-address /usr/share/doc/e3-2.8/COPYING.GPL
1 packages and 0 specfiles checked; 3 errors, 4 warnings.

rpmlint  e3-debuginfo-2.8-1.fc17.x86_64.rpm
e3-debuginfo.x86_64: E: empty-debuginfo-package
1 packages and 0 specfiles checked; 1 errors, 0 warnings.

The spelling errors seem not relevant to me.

The "statically-linked-binary" error and "missing-PT_GNU_STACK-section" error may be normal for assembly based executables, but I have no experience on this so cannot judge this. References to other similar cases may be usefull here.

The incorrect fsf address should be checked and reported upstream if needed.

The empty debug rpm should probably be disabled. See the remarks here:
https://fedoraproject.org/wiki/Packaging:Guidelines?rd=Packaging/Guidelines#Debuginfo_packages

Some remarks on the spec file:

The BuildRoot is not used by the Fedora rpmbuild and will be ignored. See:
https://fedoraproject.org/wiki/Packaging:Guidelines?rd=Packaging/Guidelines#BuildRoot_tag
so it should probably be removed.

The install steps and creation of symlinks should be reported upstream.

Comment 2 Mark McKinstry 2013-02-22 21:19:25 UTC
Jos,

> Mark, if you know more
> examples that have been accepted into Fedora, some pointers might be
> helpfull in the review process.

I haven't found any yet.

> The "statically-linked-binary" error and "missing-PT_GNU_STACK-section"
> error may be normal for assembly based executables, but I have no experience
> on this so cannot judge this. References to other similar cases may be
> usefull here.

The statically-linked-binary error is normal. Debian has an exception for e3 in its rpmlint equivalent for that error: http://lintian.debian.org/tags/statically-linked-binary.html

The missing-PT_GNU_STACK-section is not normal. After debugging it some more, I figured the problem out. If I added the fix from http://www.gentoo.org/proj/en/hardened/gnu-stack.xml#doc_chap6 ,it fixed the problem on 64 bit, but not 32 bit. After looking over the makefile and the code I found he was using the guide at http://www.muppetlabs.com/~breadbox/software/tiny/teensy.html to make a tiny ELF on 32 bit linux. Luckily you can build it the normal way to include the GNU stack stuff which is what the makefile patch I added does.

> The empty debug rpm should probably be disabled. See the remarks here:
> https://fedoraproject.org/wiki/Packaging:Guidelines?rd=Packaging/
> Guidelines#Debuginfo_packages

Fixed.

> The BuildRoot is not used by the Fedora rpmbuild and will be ignored. See:
> https://fedoraproject.org/wiki/Packaging:Guidelines?rd=Packaging/
> Guidelines#BuildRoot_tag
> so it should probably be removed.

I intend to include the package in EPEL 5 which requires the buildroot.

With the new spec and src.rpm, rpmlint should be happy, only complaining about the statically-linked-binary which is to be expected.

SPEC: http://mmckinst.fedorapeople.org/packages/e3/e3.spec
SRPM: http://mmckinst.fedorapeople.org/packages/e3/e3-2.8-3.fc17.src.rpm

Comment 3 Jos de Kloe 2013-03-07 15:14:13 UTC
Thanks for your new version, and your explanations.
My review:

Package Review
==============

Key:
[x] = Pass
[!] = Fail
[-] = Not applicable
[?] = Not evaluated

===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
     Note: rm -rf %{buildroot} present but not required
==>I take this 'present but not required' response of the fedora-review
   tool as a warning only
[x]: Sources contain only permissible code or content.
[x]: Each %files section contains %defattr if rpm < 4.4
     Note: %defattr present but not needed
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[-]: Package requires other packages for directories it uses.
[x]: Package uses nothing in %doc for runtime.
[x]: Package is not known to require ExcludeArch.
[x]: Package complies to the Packaging Guidelines
[x]: License field in the package spec file matches the actual license.
[x]: Package consistently uses macro is (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[-]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[-]: Large documentation must go in a -doc subpackage.
     Note: Documentation size is 102400 bytes in 6 files.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Fully versioned dependency in subpackages, if present.
[x]: Spec file lacks Packager, Vendor, PreReq tags.
[x]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
[x]: Package use %makeinstall only when make install' ' DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package do not use a name that already exist
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).

===== SHOULD items =====

Generic:
[x]: Uses parallel make.
==>the automatic fedora-review check complains here, but since there is
   just a single assembly file being compiled here, doing things in
   parallel doesn't make sense at all, so this is not applicable.
[?]: Buildroot is not present
     Note: Buildroot: present but not needed
==>is this EPEL5 specific?
[?]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
     Note: %clean present but not required
==>is this EPEL5 specific?
[-]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[?]: Patches link to upstream bugs/comments/lists or are otherwise justified.
==>This should item: "All patches should have an upstream bug link or comment"
   is missing in your spec file. If you think it is not usefull to
   submit the patch upstream, could you please explain.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[-]: %check is present and all tests pass.
[?]: Packages should try to preserve timestamps of original installed files.
==>it is recommended to add the '-p' flag to the install command
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Dist tag is present.
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: SourceX tarball generation or download is documented.
[x]: SourceX is a working URL.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: Spec use %global instead of %define.


===== EXTRA items =====

Generic:
[x]: Large data in /usr/share should live in a noarch subpackage if package is
     arched.
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: e3-2.8-3.fc17.x86_64.rpm
e3.x86_64: W: spelling-error Summary(en_US) pico -> pic, picot, pics
e3.x86_64: W: spelling-error Summary(en_US) nedit -> edit, n edit
e3.x86_64: W: spelling-error %description -l en_US pico -> pic, picot, pics
e3.x86_64: W: spelling-error %description -l en_US nedit -> edit, n edit
e3.x86_64: E: statically-linked-binary /usr/bin/e3
e3.x86_64: E: incorrect-fsf-address /usr/share/doc/e3-2.8/COPYING.GPL
1 packages and 0 specfiles checked; 2 errors, 4 warnings.


Rpmlint (installed packages)
----------------------------
# rpmlint e3
e3.x86_64: W: spelling-error Summary(en_US) pico -> pic, picot, pics
e3.x86_64: W: spelling-error Summary(en_US) nedit -> edit, n edit
e3.x86_64: W: spelling-error %description -l en_US pico -> pic, picot, pics
e3.x86_64: W: spelling-error %description -l en_US nedit -> edit, n edit
e3.x86_64: W: ldd-failed /usr/bin/e3
e3.x86_64: E: statically-linked-binary /usr/bin/e3
e3.x86_64: E: incorrect-fsf-address /usr/share/doc/e3-2.8/COPYING.GPL
1 packages and 0 specfiles checked; 2 errors, 5 warnings.
# echo 'rpmlint-done:'

So concluding: no new rpmlint issues, and existing issues are explained. All MUST items are fine. Still 4 SHOULD items that I would like an answer to, but they are not important enough to hold approval for the package.

Therefore this package is:

APPROVED

Comment 4 Mark McKinstry 2013-05-08 01:15:35 UTC
New Package SCM Request
=======================
Package Name: e3
Short Description: Text editor with key bindings similar to WordStar, Emacs, pico, nedit, or vi
Owners: mmckinst
Branches: f17 f18 f19 el5 el6

Comment 5 Gwyn Ciesla 2013-05-08 12:05:06 UTC
Git done (by process-git-requests).

Comment 6 Fedora Update System 2013-05-10 15:39:42 UTC
e3-2.8-3.el6 has been submitted as an update for Fedora EPEL 6.
https://admin.fedoraproject.org/updates/e3-2.8-3.el6

Comment 7 Fedora Update System 2013-05-10 15:41:17 UTC
e3-2.8-3.fc19 has been submitted as an update for Fedora 19.
https://admin.fedoraproject.org/updates/e3-2.8-3.fc19

Comment 8 Fedora Update System 2013-05-10 15:42:24 UTC
e3-2.8-3.fc18 has been submitted as an update for Fedora 18.
https://admin.fedoraproject.org/updates/e3-2.8-3.fc18

Comment 9 Fedora Update System 2013-05-10 15:43:20 UTC
e3-2.8-3.fc17 has been submitted as an update for Fedora 17.
https://admin.fedoraproject.org/updates/e3-2.8-3.fc17

Comment 10 Fedora Update System 2013-05-11 00:25:54 UTC
e3-2.8-3.fc18 has been pushed to the Fedora 18 testing repository.

Comment 11 Fedora Update System 2013-05-29 03:05:15 UTC
e3-2.8-3.fc19 has been pushed to the Fedora 19 stable repository.

Comment 12 Fedora Update System 2013-05-29 17:35:06 UTC
e3-2.8-3.el6 has been pushed to the Fedora EPEL 6 stable repository.

Comment 13 Fedora Update System 2013-05-30 02:53:02 UTC
e3-2.8-3.fc17 has been pushed to the Fedora 17 stable repository.

Comment 14 Fedora Update System 2013-05-30 03:05:44 UTC
e3-2.8-3.fc18 has been pushed to the Fedora 18 stable repository.

Comment 15 Mark McKinstry 2014-09-12 21:50:27 UTC
Package Change Request
======================
Package Name: e3
New Branches: epel7
Owners: mmckinst

Comment 16 Gwyn Ciesla 2014-09-15 12:05:51 UTC
Git done (by process-git-requests).

Comment 17 Fedora Update System 2014-10-30 02:58:05 UTC
e3-2.8-6.el7 has been submitted as an update for Fedora EPEL 7.
https://admin.fedoraproject.org/updates/e3-2.8-6.el7

Comment 18 Fedora Update System 2014-11-14 20:28:44 UTC
e3-2.8-6.el7 has been pushed to the Fedora EPEL 7 stable repository.


Note You need to log in before you can comment on or make changes to this bug.